import sys
import os
import sys
import java.lang.System as System

#  Some adminApp tasks
#
# author swisson
#
class AdminAppTasks:
    # install app if not installed. otherwise, call updateApp
    def installApp(self,appName,earFile,mapToServer):     
        try:
            lineSep = System.getProperty("line.separator")
            foundKey = 0
            listOfApps = AdminApp.list()        
            for app in listOfApps.split(lineSep):
                print "listing app: %s -- searching for app: %s" % (app, appName)
                if (app == appName):
                    print "App: %s is already installed. Updating." % (appName)
                    foundKey = 1
                    break
                else:
                    print "%s - %s didnt match. Continuing." % (app, appName)
            if earFile.find('com.ibm.tspm.server.ear') > 0:
                moduleToServers = '[[ com.ibm.tspm.mgmt.transport com.ibm.tspm.mgmt.transport.jar,META-INF/ejb-jar.xml ' + mapToServer + ' ] [ com.ibm.tspm.server.war com.ibm.tspm.server.war,WEB-INF/web.xml ' + mapToServer + ' ] [ com.ibm.tspm.distribution.policy.war com.ibm.tspm.distribution.policy.war,WEB-INF/web.xml ' + mapToServer + ' ] [ com.ibm.tspm.registration.war com.ibm.tspm.registration.war,WEB-INF/web.xml ' + mapToServer + ' ]]'
            elif earFile.find('com.ibm.tscc.rtss.agent.ear') > 0:
                moduleToServers = '[[ com.ibm.tscc.rtss.admin.ws com.ibm.tscc.rtss.admin.ws.war,WEB-INF/web.xml ' + mapToServer + ' ] [ com.ibm.tscc.rtss.agent.startup.servlet com.ibm.tscc.rtss.agent.startup.servlet.war,WEB-INF/web.xml ' + mapToServer + ' ]]'
            elif earFile.find('com.ibm.tscc.rtss.ear') > 0:
                moduleToServers = '[[ com.ibm.tscc.rtss.admin.ws com.ibm.tscc.rtss.admin.ws.war,WEB-INF/web.xml ' + mapToServer + ' ] [ com.ibm.tscc.rtss.authz.ws com.ibm.tscc.rtss.authz.ws.war,WEB-INF/web.xml ' + mapToServer + ' ] [ com.ibm.tscc.rtss.startup.servlet com.ibm.tscc.rtss.startup.servlet.war,WEB-INF/web.xml ' + mapToServer + ' ]]'
            else:
                raise NameError, "Unknown enterprise application ear file passed in: %s" % (earFile)
            if (foundKey == 1):
                self.updateApp(appName,earFile)
            else:
                print "App: %s not installed. Installing now." % (appName)
                AdminApp.install(earFile, '[ -MapModulesToServers ' + moduleToServers + ']')
        except:
            e = sys.exc_info()[1]
            print e
            raise
    # update the already installed app       
    def updateApp(self,appName,earFile):
        try:
            #earFile = '${context:installLocation}\pkg\com.ibm.tspm.server.ear'
            AdminApp.update(appName, 'app', '[ -operation update -contents \"' + earFile + '\" -update.ignore.new -nopreCompileJSPs -distributeApp -nouseMetaDataFromBinary -deployejb -createMBeansForResources -reloadEnabled -reloadInterval 98 -nodeployws -validateinstall warn -processEmbeddedConfig ]')
        except:
            e = sys.exc_info()[1]
            print e
            raise
    # uninstall app if installed.
    def uninstallApp(self,appName):     
        try:
            lineSep = System.getProperty("line.separator")
            foundKey = 0
            listOfApps = AdminApp.list()        
            for app in listOfApps.split(lineSep):
                print "listing app: %s -- searching for app: %s" % (app, appName)
                if (app == appName):
                    print "App: %s is installed. Uninstalling." % (appName)
                    foundKey = 1
                    break
                else:
                    print "%s - %s didnt match. Continuing." % (app, appName)
            if (foundKey == 1):
                try:    
                    self.stopApp(appName)
                except:
                    print "app not running. continuing."
                AdminApp.uninstall(appName)
            else:
                print "App: %s not installed. Nothing to do here." % (appName)     
        except:
            e = sys.exc_info()[1]
            print e
            raise       
    # start app. duh       
    def startApp(self,appName):
        try:
            lineSep = System.getProperty("line.separator")
            if lineSep == '\r\n':
                appName = '[\"' + appName + '\"]'
            elif lineSep == '\n':
                appName = '[\"' + appName + '\"]'
            else:
                print "no matching line separator"
            appManager = AdminControl.queryNames('type=ApplicationManager,*')
            AdminControl.invoke(appManager,'startApplication',appName)
        except:
            e = sys.exc_info()[1]
            print e
            #raise
    #stop app.   
    def stopApp(self,appName):
        try:
            lineSep = System.getProperty("line.separator")
            if lineSep == '\r\n':
                appName = '[\"' + appName + '\"]'
            elif lineSep == '\n':
                appName = '[\"' + appName + '\"]'
            else:
                print "no matching line separator"
            appManager = AdminControl.queryNames('type=ApplicationManager,*')
            AdminControl.invoke(appManager,'stopApplication',appName)
        except:
            e = sys.exc_info()[1]
            print e
            #raise
      
# Script entry
arglen = len(sys.argv)
#print "Argv length: %d" % (arglen)
#print sys.argv[0]
#print sys.argv[1]

phase = sys.argv[0]
action = sys.argv[1]
app = sys.argv[2]
if arglen > 3:
    earFile = sys.argv[3]
    mapToServer = sys.argv[4]
    if earFile.find('"') == 0:
        earFile = earFile[1:]
    if earFile.find('"') == len(earFile)-1:
        earFile = earFile[:len(earFile)-1]
        if earFile.find('"') == len(earFile)-1:
            earFile = earFile[:len(earFile)-1]
    print "earFile is now stripped: %s" % (earFile)

try:  
    if app.find('"') == 0:
        app = app[1:]
    if app.find('"') == len(app)-1:
        app = app[:len(app)-1]
        if app.find('"') == len(app)-1:
            app = app[:len(app)-1]
    print "app is now stripped: %s" % (app)
    adminAppTasks = AdminAppTasks()
    AdminConfig.reset()
    if phase.find('uninstall') >= 0:
        if action != "update" and action != "rollback":
            adminAppTasks.uninstallApp(app)
            AdminConfig.save()
        else:
            print "The action is update or rollback; leaving the app for an AdminApp.update downstream."
    elif phase.find('install') >= 0:
        adminAppTasks.installApp(app,earFile,mapToServer)
        AdminConfig.save()
    elif phase == "stopApp":
        adminAppTasks.stopApp(app)
    elif phase == "startApp":
        adminAppTasks.startApp(app)
    else:
        print "Task of phase action: %s not supported." % (phase)
except:
    e = sys.exc_info()[1]
    print e
    raise