#!/bin/sh
# THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
# 5724-S24  (C) COPYRIGHT International Business Machines Corp., 2009,2010
# All Rights Reserved * Licensed Materials - Property of IBM
# US Government Users Restricted Rights - Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp
#
#
# Runs the Tivoli PDT Registration program 
# Run the setupCmdLine.sh in the <WAS_HOME>/bin directory before using this script
#DEBUG="-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=n,address=7778"

VMARGS="-Dfile.encoding=UTF-8 ${DEBUG}"


if [[ -z "$WAS_HOME" ]] ; then
    echo "Environment is not setup. Please run the setupCmdLine.sh in the <WAS_HOME>/profiles/<profile-name>/bin directory before using this script."
    exit 1
fi

CMDDIR=`dirname $0`
cd $CMDDIR


if [ -f "${WAS_HOME}/plugins/com.ibm.ws.runtime_6.1.0.jar" ] ; then
   ##  WAS 6.1
   LOCAL_CLASSPATH="${WAS_HOME}"/runtimes/com.ibm.jaxws.thinclient_6.1.0.jar:"${WAS_HOME}"/runtimes/com.ibm.ws.admin.client_6.1.0.jar:./com.ibm.tscc.rtss.tools.register_7.1.0.jar:${WAS_HOME}/plugins/com.ibm.ws.runtime_6.1.0.jar:${WAS_HOME}/plugins/com.ibm.ws.emf_2.1.0.jar
else
   ##  WAS 7.0+
    LOCAL_CLASSPATH="${WAS_HOME}"/runtimes/com.ibm.jaxws.thinclient_7.0.0.jar:"${WAS_HOME}"/runtimes/com.ibm.ws.admin.client_7.0.0.jar:./com.ibm.tscc.rtss.tools.register_7.1.0.jar:"${WAS_HOME}"/plugins/com.ibm.ws.security.crypto.jar

fi

$JAVA_HOME/bin/java -cp $LOCAL_CLASSPATH ${VMARGS} com.ibm.tscc.rtss.tspm.registration.TSPMRegisterRTSS $@
