/* %Z%%M% %I% %W% %G% %U%
 * ===========================================================================
 * Licensed Materials - Property of IBM
 * All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * 
 * 5724-S24
 * (C) Copyright IBM Corp. 2010
 * ===========================================================================
 */

package com.ibm.tscc.rtss.authz.ws.xacml.rtss.authzservice;

import javax.naming.InitialContext;
import javax.naming.NamingException;

import java.net.URL;

import javax.xml.namespace.QName;
import javax.xml.transform.Source;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.Dispatch;
import javax.xml.ws.Service;
import com.ibm.tivoli.security.schemas.entitlements.EntitlementRequestType;
import com.ibm.tivoli.security.schemas.entitlements.EntitlementResponseType;
import oasis.names.tc.saml._2_0.protocol.RequestAbstractType;
import oasis.names.tc.xacml._2_0.context.schema.os.RequestType;

public class AuthzServiceSOAPProxy{

    protected Descriptor _descriptor;

    public class Descriptor {
        private com.ibm.tscc.rtss.authz.ws.xacml.rtss.authzservice.AuthzService_Service _service = null;
        private com.ibm.tscc.rtss.authz.ws.xacml.rtss.authzservice.AuthzService _proxy = null;
        private Dispatch<Source> _dispatch = null;

        public Descriptor() {
            try
            {
                InitialContext ctx = new InitialContext();
                _service = (com.ibm.tscc.rtss.authz.ws.xacml.rtss.authzservice.AuthzService_Service)ctx.lookup("java:comp/env/service/AuthzService");
            }
            catch (NamingException e)
            {
                if ("true".equalsIgnoreCase(System.getProperty("DEBUG_PROXY"))) {
                    System.out.println("NamingException: " + e.getMessage());
                    e.printStackTrace(System.out);
                }
            }

            if (_service == null)
                _service = new com.ibm.tscc.rtss.authz.ws.xacml.rtss.authzservice.AuthzService_Service();
            initCommon();
        }

        public Descriptor(URL wsdlLocation, QName serviceName) {
            _service = new com.ibm.tscc.rtss.authz.ws.xacml.rtss.authzservice.AuthzService_Service(wsdlLocation, serviceName);
            initCommon();
        }

        private void initCommon() {
            _proxy = _service.getAuthzServiceSOAP();
        }

        public com.ibm.tscc.rtss.authz.ws.xacml.rtss.authzservice.AuthzService getProxy() {
            return _proxy;
        }

        public Dispatch<Source> getDispatch() {
            if (_dispatch == null ) {
                QName portQName = new QName("http://xacml.ws.authz.rtss.tscc.ibm.com/rtss/AuthzService", "AuthzServiceSOAP");
                _dispatch = _service.createDispatch(portQName, Source.class, Service.Mode.MESSAGE);

                String proxyEndpointUrl = getEndpoint();
                BindingProvider bp = (BindingProvider) _dispatch;
                String dispatchEndpointUrl = (String) bp.getRequestContext().get(BindingProvider.ENDPOINT_ADDRESS_PROPERTY);
                if (!dispatchEndpointUrl.equals(proxyEndpointUrl))
                    bp.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, proxyEndpointUrl);
            }
            return _dispatch;
        }

        public String getEndpoint() {
            BindingProvider bp = (BindingProvider) _proxy;
            return (String) bp.getRequestContext().get(BindingProvider.ENDPOINT_ADDRESS_PROPERTY);
        }

        public void setEndpoint(String endpointUrl) {
            BindingProvider bp = (BindingProvider) _proxy;
            bp.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, endpointUrl);

            if (_dispatch != null ) {
                bp = (BindingProvider) _dispatch;
                bp.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, endpointUrl);
            }
        }
    }

    public AuthzServiceSOAPProxy() {
        _descriptor = new Descriptor();
    }

    public AuthzServiceSOAPProxy(URL wsdlLocation, QName serviceName) {
        _descriptor = new Descriptor(wsdlLocation, serviceName);
    }

    public Descriptor _getDescriptor() {
        return _descriptor;
    }

    public oasis.names.tc.xacml._2_0.context.schema.os.ResponseType evaluateXACML(RequestType xacmlRequest) {
        return _getDescriptor().getProxy().evaluateXACML(xacmlRequest);
    }

    public oasis.names.tc.saml._2_0.protocol.ResponseType evaluateSAML(RequestAbstractType samlRequest) {
        return _getDescriptor().getProxy().evaluateSAML(samlRequest);
    }

    public EntitlementResponseType evaluateEntitlements(EntitlementRequestType entitlementRequest) {
        return _getDescriptor().getProxy().evaluateEntitlements(entitlementRequest);
    }

}